------------------------------------------------------------------------
-- The Agda standard library
--
-- All library modules, along with short descriptions
------------------------------------------------------------------------

-- Note that core modules are not included.


{-# OPTIONS --safe --sized-types #-}

module EverythingSafeSizedTypes where

-- "Finite" sets indexed on coinductive "natural" numbers
import Codata.Cofin

-- Conat Literals
import Codata.Cofin.Literals

-- The Colist type and some operations
import Codata.Colist

-- Bisimilarity for Colists
import Codata.Colist.Bisimilarity

-- A categorical view of Colist
import Codata.Colist.Categorical

-- Properties of operations on the Colist type
import Codata.Colist.Properties

-- The Conat type and some operations
import Codata.Conat

-- Bisimilarity for Conats
import Codata.Conat.Bisimilarity

-- Conat Literals
import Codata.Conat.Literals

-- Properties for Conats
import Codata.Conat.Properties

-- The Covec type and some operations
import Codata.Covec

-- Bisimilarity for Covecs
import Codata.Covec.Bisimilarity

-- A categorical view of Covec
import Codata.Covec.Categorical

-- Properties of operations on the Covec type
import Codata.Covec.Properties

-- The Cowriter type and some operations
import Codata.Cowriter

-- Bisimilarity for Cowriter
import Codata.Cowriter.Bisimilarity

-- The Delay type and some operations
import Codata.Delay

-- Bisimilarity for the Delay type
import Codata.Delay.Bisimilarity

-- A categorical view of Delay
import Codata.Delay.Categorical

-- Properties of operations on the Delay type
import Codata.Delay.Properties

-- M-types (the dual of W-types)
import Codata.M

-- Bisimilarity for M-types
import Codata.M.Bisimilarity

-- Properties of operations on M-types
import Codata.M.Properties

-- The Stream type and some operations
import Codata.Stream

-- Bisimilarity for Streams
import Codata.Stream.Bisimilarity

-- A categorical view of Stream
import Codata.Stream.Categorical

-- Properties of operations on the Stream type
import Codata.Stream.Properties

-- The Thunk wrappers for sized codata, copredicates and corelations
import Codata.Thunk

-- Containers, based on the work of Abbott and others
import Data.Container

-- The free monad construction on containers
import Data.Container.FreeMonad

-- Rose trees
import Data.Tree.Rose

-- Properties of rose trees
import Data.Tree.Rose.Properties

-- Trie, basic type and operations
import Data.Trie

-- Non empty trie, basic type and operations
import Data.Trie.NonEmpty

-- Sizes for Agda's sized types
import Size

-- 1 dimensional pretty printing of rose trees
import Text.Tree.Linear

